# encoding: UTF-8
=begin
Created on 2015-04-08

@author: Nikolay Moskvin <moskvin@sibext.com>

=end

module Croket
  module Rails
    class Middleware

      def initialize app
        @app = app
      end

      def call env
        begin
          response = @app.call env
        rescue Exception => e
          notify_croket env, e
          raise e
        end
        if framework_exception = env["action_dispatch.exception"]
          notify_croket env, framework_exception
        end
        #p env["rack.errors"], env["action_dispatch.show_exceptions"], env["action_dispatch.show_detailed_exceptions"]
        p env.keys.select {|i| i.include? 'exception' or i.include? 'err'}
        response
      end

      private

      def notify_croket env, e
        Croket.notify e, env
      end

    end
  end
end
