# encoding: UTF-8
=begin
Created on 2015-04-08

@author: Nikolay Moskvin <moskvin@sibext.com>

=end

require 'rails'
require 'croket/rails/middleware'

module Croket
  
  class Railtie < ::Rails::Railtie
    initializer 'croket.middleware' do |app|

      middleware = if defined?(ActionDispatch::DebugExceptions)
        # Rails >= 3.2.0
        "ActionDispatch::DebugExceptions"
      else
        # Rails < 3.2.0
        "ActionDispatch::ShowExceptions"
      end

      app.config.middleware.insert_after middleware, "Croket::Rails::Middleware"
      #app.config.middleware.insert 0, "Croket::Rails::Middleware"
    end

    config.after_initialize do
      ActiveSupport.on_load(:action_controller) do
        # Lazily load action_controller methods
        #
        require 'croket/rails/controller_methods'

        include Croket::Rails::ControllerMethods
      end
    end

  end

end
